@class NSColor, NSView;

/*NSFocusRingPlacement

The focus ring style indicates how the focus ring will be drawn. 

typedef enum {
   NSFocusRingOnly  = 0,
   NSFocusRingBelow = 1,
   NSFocusRingAbove = 2
} NSFocusRingPlacement;
Constants
NSFocusRingAbove

Use NSFocusRingAbove to draw over an image.

Fill a shape to add the focus ring around the shape.

Available in Mac OS X v10.1 and later.
NSFocusRingBelow

Use NSFocusRingBelow to draw the focus ring under text.

Available in Mac OS X v10.1 and later.
NSFocusRingOnly

Use NSFocusRingOnly if you don’t have an image or text.

Available in Mac OS X v10.1 and later.
Availability
Available in Mac OS X v10.1 and later.
Declared In
NSGraphics.h*/
typedef enum {
   NSFocusRingOnly  = 0,
   NSFocusRingBelow = 1,
   NSFocusRingAbove = 2
} NSFocusRingPlacement;



/*NSSetFocusRingStyle

Specifies how a focus ring will be drawn.

void NSSetFocusRingStyle(NSFocusRingPlacement placement)
Discussion

The focus ring style indicates how the focus ring will be drawn. Use NSFocusRingAbove to draw over an image, use NSFocusRingBelow to draw the focus ring under text, and use NSFocusRingOnly if you don’t have an image or text. For the NSFocusRingOnly case, fills a shape to add the focus ring around the shape.

Note that the focus ring may actually be drawn outside the view but will be clipped to any clipping superview or the window content view.
Availability
Available in Mac OS X v10.1 and later.*/
void NSSetFocusRingStyle(NSFocusRingPlacement placement);