#ifndef DRAG_H
#define DRAG_H

#ifndef APPLICATIONSERVICES_H
#include <ApplicationServices/ApplicationServices.h>
#endif

#ifndef EVENTS_H
#include <HIToolbox/Events.h>
#endif


#include <HYS/HIToolbox/Drag.h>
#include <AvailabilityMacros.h>

#if PRAGMA_ONCE
#pragma once
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*DragRef

Defines a reference to a drag object.

typedef struct OpaqueDragRef * DragRef;
Discussion

Before calling any other Drag Manager function, you must first create a new drag reference by calling the NewDrag function. The drag reference that is returned by the NewDrag function is used in all subsequent calls to the Drag Manager. Use the DisposeDrag function to dispose of a drag reference after you are finished using it.

The meaning of the bits in a drag reference is internal to the Drag Manager. You should not attempt to interpret the value of the drag reference. 
Availability
Available in Mac OS X v10.0 and later.*/
typedef struct OpaqueDragRef * DragRef;

#ifdef __cplusplus
}
#endif

#endif